%define libmaj 0
%define libmin 9
%define librel 6
%define liblet k

%define openssldir /etc/ssl

Summary:	Secure Sockets Layer and cryptography libraries and tools
Name:		openssl
Version:	%{libmaj}.%{libmin}.%{librel}%{liblet}
Release:	1.3.2
Source0:	%{name}-engine-%{version}.tar.gz
Patch0:		openssl-engine-0.9.6g-Configure-gd-1.diff
Patch1:		openssl-engine-0.9.6d-Makefile-gd-1.diff
Copyright:	Freely distributable
Group:		Applications/Cryptography
Provides:	SSL, libcrypto.so.0, libssl.so.0
BuildRoot:	%{_tmppath}/%{name}-%{release}-root

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide. The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes. 

This package contains the base OpenSSL cryptography and SSL/TLS 
libraries and tools.

%files
  %defattr(0644,root,root,0755)
  %doc CHANGES CHANGES.SSLeay LICENSE NEWS README
  %doc doc
  %doc %{_mandir}/man*/*
  %attr(0755,root,root) %{_bindir}/*
  %attr(0755,root,root) %{_libdir}/*.so*
  %attr(0644,root,root) %config(noreplace) %{openssldir}/openssl.cnf
  %dir %attr(0755,root,root) %{openssldir}/certs
  %dir %attr(0750,root,root) %{openssldir}/private
  %attr(0750,root,root) %dir /etc/ssl

%package misc
Summary:	OpenSSL X.509 tools
Group:		Applications/Cryptography
Requires:	%{name} = %{version}

%description misc
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide. The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes. 

This package contains assorted scripts for X.509 certificate generation
and processing.

%files misc
  %attr(0755,root,root) /usr/bin/CA.pl
  %attr(0755,root,root) /usr/bin/CA.sh
  %attr(0755,root,root) /usr/bin/c_hash
  %attr(0755,root,root) /usr/bin/c_info
  %attr(0755,root,root) /usr/bin/c_issuer
  %attr(0755,root,root) /usr/bin/c_name
  %attr(0755,root,root) /usr/bin/der_chop

%package devel
Summary:	OpenSSL - Secure Sockets Layer and cryptography static libraries and headers
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description devel
This package contains the the OpenSSL cryptography and SSL/TLS
static libraries and header files required when developing applications.

Note: Built without RC5 and IDEA ciphers to avoid patent infringement.

%files devel
  %defattr(-,root,root)
  %doc demos
  %{_includedir}/openssl
  %attr(0644,root,root) %{_libdir}/*.a

%prep
%setup -q -n %{name}-engine-%{version}
%patch0 -p1
%patch1 -p1

%build 
  CC="$RPM_OPT_FLAGS" ./Configure -DOPENSSL_FORCE_RSA_BLINDING \
	--prefix=%{_prefix} --openssldir=%{openssldir} \
	no-idea no-rc5 linux-elf
  make all
  make build-shared

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  make install MANDIR=%{_mandir} INSTALL_PREFIX="$RPM_BUILD_ROOT"

  # Rename manpages
  for x in $RPM_BUILD_ROOT%{_mandir}/man*/* 
	do mv ${x} ${x}ssl
  done

  # Install shared libs
  install -m755 libcrypto.so.%{libmaj}.%{libmin}.%{librel} $RPM_BUILD_ROOT/usr/lib
  install -m755 libssl.so.%{libmaj}.%{libmin}.%{librel} $RPM_BUILD_ROOT/usr/lib
  (
	cd $RPM_BUILD_ROOT/usr/lib
	ln -s libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so.%{libmaj}
	ln -s libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so
	ln -s libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so.%{libmaj}
	ln -s libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so
  )

  # Move misc tools to /usr/bin
  mv $RPM_BUILD_ROOT/%{openssldir}/misc/* $RPM_BUILD_ROOT/usr/bin

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Sep 30 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6i, Release 1.3.2
  - Upgrade to 0.9.6k to fix the blinding memory leaks.  This
    upgrade fixes the problems we were seeing with stunnel
    under very high load (the "bad mac" errors in syslog).

* Tue Sep 30 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6i, Release 1.3.1
  - [CAN-2003-0545, CAN-2003-0543, and CAN-2003-0544] Fixes for ASN.1
    parsing bugs, as reported by NISCC.

* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Wed Mar 19 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6i, Release 1.5.4
  - [CAN-2003-0147] Use RSA blinding by default.
  - [CAN-2003-0131] Fix for Klima/Pokorny/Rosa Bleichenbacher attack extension.

* Wed Feb 19 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6i, Release 1.5.3
  - Upgrade to 0.9.6i (includes security fix).

* Tue Feb 18 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6h, Release 1.5.2
  - Provide libcrypto.so.0 and libssl.so.0 for compatability.

* Fri Feb 14 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6h, Release 1.5.1
  - Upgrade to latest (openssl-engine) stable version.
  - Rewrite spec to make it look like openssl-engine spec.

* Mon Feb 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Wed Aug 07 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6, Release 1.2.3
  - Fix the ASN.1 fix.

* Sat Jul 27 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6, Release 1.2.[12]
  - Fix some more security bugs found by way of Mark Cox.

* Mon Feb 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.2.0
  - Initial build for EnGarde v1.2 (Parry).

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6, Release 1.1.0
  - Initial build for EnGarde v1.1 (Balestra).

* Thu Jul 05 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6, Release 1.0.14
  - Applied two patches to the PRNG code.  Thanks to Mark J. Cox of Red Hat.

* Wed Apr 25 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.9.6, Release 1.0.13
  - SECURITY:  Fixes several bugs, with 0.9.6a changes backported to
               0.9.6 by Nalin.

* Mon Nov 27 2000 Dave Wreski <dave@guardiandigital.com>
- fix oops with libssl.so.*

* Mon Nov 27 2000 Dave Wreski <dave@guardiandigital.com>
- fixed libssl package problem

* Tue Nov 21 2000 Dave Wreski <dave@guardiandigital.com>
- added devel package

* Sat Oct 28 2000 Dave Wreski <dave@guardiandigital.com>
- fhs cleanup
- upgrade to 0.9.6
- makefile patch to remove -g from openssl compile
- removed rsaref files

* Fri Aug 11 2000 Dave Wreski <dave@guardiandigital.com>
- initial rpm from Damien Miller spec file
